#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include "a2dc.h"


int main(void){
 int fo;
 static unsigned char i;
 static unsigned char mask=~0x7f,mask2=0;
 static unsigned char test[13]={0xFF,0x00,0xaa,
 			0x55,0xaf,0xfa,
 			0x5f,0x5f,0xa5,
 			0x5a,0xff,0x00};

/* ovaj program u biti pali i gasi diode */
/* simulira neke 0x05 i 0x0A testove,    */
/* i na kraju binarno broji 		 */

 
puts("\nTest digitalnog izlaza.");
puts("Paljenje i gasenje, kombinacije F,5,A,0 i binarno brojilo");
puts("Program se prekida pomocu kill -9 <PID>");

if ( (fo=open("/dev/das08jr_dio",O_RDWR)) < 0){
	printf("\n\tNe mogu otvoriti dio!");
	exit (-1);
}

/* NAPOMENA */
/* Ovaj sizeof( unsigned char ) u pozivima funkcije write    */
/* nema veze s mozgom, jer tu bi trebao stajati broj biteova */
/* koji se upisuju. Iz nekog razloga ovaj gcc u labosu nesto */
/* radi krivo, tako da program jedino ovako radi. Da li je   */
/* to problem u optimizacijama (gcc -O2) KOJE MORAJU BITI    */
/* pozvane ili su to Murphyjevi efekti - nemam pojma.        */
/* Sa starijom verzijom gcc-a sve radi OK.		     */

/* Ovo radi OK zato sto je sizeof(unsigned char) iznosi 1    */
/* sto i treba pisati na tom mjestu.                         */

/* U svakom slucaju, trebalo bi natjerati stvar da radi s    */
/* brojkom 1 upisanom tamo gdje treba biti upisana           */

while(1){
mask2=0x00;
write(fo,&mask2,sizeof( unsigned char));
usleep(500000);
mask2=~mask2;
write(fo,&mask2,sizeof( unsigned char));
usleep(500000);
mask2=~mask2;
write(fo,&mask2,sizeof( unsigned char));
usleep(500000);
mask2=~mask2;
write(fo,&mask2,sizeof( unsigned char));
usleep(500000);
mask2=~mask2;
write(fo,&mask2,sizeof( unsigned char));
usleep(500000);
mask2=~mask2;
write(fo,&mask2,sizeof( unsigned char));
usleep(500000);


for(i=0;i<9;i++){
mask2=~( mask >> i);
write(fo,&mask2,sizeof( unsigned char));
usleep(500000);
}

for(i=0;i<13;i++){
 write(fo,&test[i],sizeof( unsigned char));
 usleep(500000);
}

for(i=255;i>0;i--){
 write(fo,&i,sizeof( unsigned char));
 usleep(100000);
}
i=0;
write(fo,&i,sizeof( unsigned char));
usleep(100000);
}
close(fo);
return(1);
}
